<?php
	/*
	File Name: process.php
	Author: Łukasz "Rutek" Rutkowski
	Author URI: http://eazu.pl/
	License: GPL2
	*/
	class Process {
		private static $pids;
		public function __construct($code) {
			$pid = pcntl_fork();
			if($pid != 0) {
				return;
			}
			eval($code);
			exit();
		}
		public static function start() {
			$pid = pcntl_fork();
			if($pid != 0) {
				return FALSE;
			} else {				
				self::$pids[] = getmypid();
				return TRUE;
			}
		}
		public static function end() {
			$pid = self::getPID();
			posix_kill($pid, 9);
		}
		public static function unattach() {
			posix_setsid();
		}
		public static function getPID() {
			return getmypid();
		}
		public static function killZombies() {
			$parentPID = Process::getPID();
			exec('ps -fe | grep "<defunct>" | awk \'$3 == '.$parentPID.' { print $2 }\'', $pids);
			foreach($pids as $pid) {
				pcntl_waitpid($pid, $status);
			}
		}
		// $no = do not kill parent
		public static function killParentWithChilds($parentPID, $no=FALSE) {
			exec('ps -ef | awk \'$3 == \''.$parentPID.'\' { print  $2 }\'', $buff);
			foreach($buff as $proc) {
				if($proc != $parentPID) {
					self::killParentWithChilds($proc);
				}
			}
			if($no == FALSE) {
				posix_kill($parentPID, 9);
			}
		}
	}
